/* }EX֌W */

#include "bootpack.h"
#include <stdio.h>

struct FIFO32 *mousefifo;
int mousedata0;

void inthandler2c(int *esp)
/* PS/2}EX̊荞 */
{
	int data;
	io_out8(PIC1_OCW2, 0x64);	/* IRQ-12tPIC1ɒʒm */
	io_out8(PIC0_OCW2, 0x62);	/* IRQ-02tPIC0ɒʒm */
	data = io_in8(PORT_KEYDAT);
	fifo32_put(mousefifo, data + mousedata0);
	return;
}

#define KEYCMD_SENDTO_MOUSE		0xd4
#define MOUSECMD_ENABLE			0xf4

void enable_mouse(struct FIFO32 *fifo, int data0, struct MOUSE_DEC *mdec)
{
	int result, i;
	static unsigned char cmd[7] = {
		0xF3, /* TvO[gݒ */
		0xC8, /* 200 */
		0xF3, /* TvO[gݒ */
		0x64, /* 100 */
		0xF3, /* TvO[gݒ */
		0x50, /* 80 */
		0xF2  /* foCX^Cv擾 */
	};

	/* ݐFIFOobt@L */
	mousefifo = fifo;
	mousedata0 = data0;

	/* zC[}EX */
	for (i = 0; i < 7; i++) {
		wait_KBC_sendready();
		io_out8(PORT_KEYCMD, KEYCMD_SENDTO_MOUSE);
		wait_KBC_sendready();
		io_out8(PORT_KEYDAT, cmd[i]);
	}

	/* foCX^Cv擾 */
	io_cli();
	for (i = 0; i < 8; i++) {
		result = io_in8(PORT_KEYDAT);
	}
	io_sti();

	/* zC[Lǂ`FbN */
	if (result == 0x03) {
		mdec->scrollmode = 1;
	} else {
		mdec->scrollmode = 0;
	}

	/* }EXL */
	wait_KBC_sendready();
	io_out8(PORT_KEYCMD, KEYCMD_SENDTO_MOUSE);
	wait_KBC_sendready();
	io_out8(PORT_KEYDAT, MOUSECMD_ENABLE);
	/* ܂ACK(0xfa)MĂ */
	mdec->phase = 0; /* }EX0xfa҂ĂiK */
	return;
}

int mouse_decode(struct MOUSE_DEC *mdec, unsigned char dat)
{
	if (mdec->phase == 0) {
		/* }EX0xfa҂ĂiK */
		if (dat == 0xfa) {
			mdec->phase = 1;
		}
		return 0;
	}
	if (mdec->phase == 1) {
		/* }EX1oCgڂ҂ĂiK */
		if ((dat & 0xc8) == 0x08) {
			/* 1oCgڂ */
			mdec->buf[0] = dat;
			mdec->phase = 2;
		}
		return 0;
	}
	if (mdec->phase == 2) {
		/* }EX2oCgڂ҂ĂiK */
		mdec->buf[1] = dat;
		mdec->phase = 3;
		return 0;
	}
	if (mdec->phase == 3) {
		/* }EX3oCgڂ҂ĂiK */
		mdec->buf[2] = dat;
		if (mdec->scrollmode != 0) {
			mdec->phase = 4;
		} else {
			mdec->phase = 1;
		}
		mdec->btn = mdec->buf[0] & 0x07;
		mdec->x = mdec->buf[1];
		mdec->y = mdec->buf[2];
		if ((mdec->buf[0] & 0x10) != 0) {
			mdec->x |= 0xffffff00;
		}
		if ((mdec->buf[0] & 0x20) != 0) {
			mdec->y |= 0xffffff00;
		}
		mdec->y = - mdec->y; /* }EXły̕ʂƔ */
		if (mdec->scrollmode != 0) {
			return 0;
		} else {
			return 1;
		}
	}
	if (mdec->phase == 4) {
		/* }EX4oCgڂ҂ĂiK */
		mdec->buf[3] = dat;
		/* XN[Ή}EX̂݃XN[ */
		mdec->phase  = 1;
		/* mdec.buf[3]́A4rbgLȒlł */
		/* Ƃ肠͂ɒl܂ */
		mdec->scroll = mdec->buf[3] & 0x0f;
		if (mdec->scroll & 0x08) {
			/* }CiX̒l */
			mdec->scroll |= 0xfffffff0;
		}
		return 1;
	}
	return -1; /* ɗ邱Ƃ͂Ȃ͂ */
}
